define([
    'taoQtiItem/qtiCreator/widgets/states/factory',
    'taoQtiItem/qtiCreator/widgets/interactions/states/Question',
    'taoQtiItem/qtiCreator/widgets/helpers/formElement',
    'tpl!CodeBlockProgrammingInteraction/creator/tpl/propertiesForm',
    'tpl!CodeBlockProgrammingInteraction/creator/tpl/choicePanel',
    'CodeBlockProgrammingInteraction/creator/widget/utils',
    'CodeBlockProgrammingInteraction/creator/Rectangle',
    'CodeBlockProgrammingInteraction/creator/Panel',
    'CodeBlockProgrammingInteraction/creator/ToCode',
    'CodeBlockProgrammingInteraction/creator/AnswerView',
    'CodeBlockProgrammingInteraction/runtime/js/NotifyDialog',
    'taoQtiItem/qtiCreator/helper/xmlRenderer',

], function (stateFactory, Question, formElement, formTpl, choiceTpl, utils, Rectangle, Panel, ToCode, AnswerView, NotifyDialog, xmlRenderer) {
    let observer;
    let initialized = false;
    let answerView = null;

    const LiquidsInteractionStateQuestion = stateFactory.extend(Question, function (...args) {
        //ここは問題タブが有効になった際に叩かれる
        //add transparent protective layer\

        const widget = this.widget;
        const $container = this.widget.$container
            , $prompt = $container.find(".prompt")
            , interaction = this.widget.element
            , $title = $container.find('.question-title');

        let $form = widget.$form;
        const options = interaction.prop('options');
        const execTime = options.execTime;
        const repeatFlag = utils.toBoolean(options.repeatFlag);
        const hintFlag = utils.toBoolean(options.hintFlag);
        const hint = options.hint;

        interaction.triggerPci('changeEditorTab', ["QUESTION"]);
        let $repeatFlg = $form.find('input[name="repeat_flg"]');
        let $execTime = $form.find('input[name="exectime"]');
        let $hintFlg = $form.find('input[name="hint_flg"]');
        let $hint = $form.find('textarea[name="hint"]');

        $repeatFlg.attr('checked', repeatFlag)
        $repeatFlg.on('click', function () {
            interaction.triggerPci('changeRepeatFlag', [this.checked]);
        });

        $hintFlg.attr('checked', hintFlag)
        $hintFlg.on('click', function () {
            interaction.triggerPci('changeHintFlag', [this.checked]);
        });

        $execTime.val(execTime)
        $execTime.on('input', function () {
            interaction.triggerPci('changeExecTime', [$(this).val()]);
        });

        $hint.val(hint)
        window.setTimeout(function () {
            utils.updateHeightTextarea($hint)
        }, 10);
        $hint.on('input', function () {
            utils.updateHeightTextarea($(this))
            interaction.triggerPci('changeHint', [$(this).val()]);
        });


        const createId = () => {
            //TODO　良いロジック浮かんだら変更　30ループ程度出し大丈夫そう
            for (let i = 1; i <= 30; i++) {
                if (!$container.find(`[data-rectangle-id=code_${i}]`).length)
                    return "code_" + i
            }
        }
        let targetId = null;
        //選択中の短冊にbox-shadowをつける
        const changeTarget = (target) => {
            if (targetId) {
                const prevs = $container[0].getElementsByClassName('current')
                Array.from(prevs).forEach((prev) => {
                    prev.classList.remove("current");
                })
            }

            targetId = target.getAttribute("data-rectangle-id")
            const currents = $container[0].querySelectorAll(`[data-rectangle-id=${targetId}`)
            currents.forEach((current) => {


                current.classList.add("current")
            })
        }

        const checkSameLocked = (rectid) => {
            const sameCode = Array.from($container[0].getElementsByClassName("right-container")[0].querySelectorAll(`[data-rectangle-id=${rectid}]`))
            const sameCodeLocked = sameCode.filter((item) => item.lastElementChild.classList.contains("locked"))

            if (sameCodeLocked.length && sameCode.length == sameCodeLocked.length) {
                $('.left-container > [data-rectangle-id="' + rectid + '"]').hide();
            }
        }

        $container.on('click', '.right-container .lock', function () {
            let rectid = $(this).parent().attr('data-rectangle-id');
            const $parentRect = $(this).parent()
            // $parentRect.find('.rmv').remove();
            $parentRect.find('.rmv').each(function () {
                if (!$(this).parent().hasClass('spacerectangle')) {
                    $(this).remove();
                }
            });
            $parentRect.append('<div class="locked"></div>');
            $parentRect.addClass('filter');
            $(this).eq(1).remove();
            $(this).remove();
            checkSameLocked(rectid)
            $parentRect.find(".lock").trigger("click")
        })

        $container.on('click', '.right-container .locked', function () {
            $(this).parent().find('.locked').each(function (index, elem) {
                let rectid = $(this).parent().attr('data-rectangle-id');
                $('.left-container > [data-rectangle-id="' + rectid + '"]').show();
            })
            $(this).parent().find('.locked').parent().append('<div class="rmv"></div>');
            $(this).parent().find('.locked').parent().append('<div class="lock"></div>');
            $(this).parent().find('.locked').parent().removeClass("filter");
            $(this).parent().find('.locked').remove();
        })
        $container.on('click', '.rectangle', function (e) {
            e.stopPropagation();
            changeTarget(this);
            Panel.createPanel(this, $container)
            const preValue = this.getAttribute('data-rectangle-id');
            if (this.getAttribute('data-rectangle-exec-value')?.length < 1) {
                this.classList.add('block-alert-border');
                this.classList.add('filter');
                this.querySelector('.block-alert').classList.remove('d-none');
                $('#execRectangleValue').after('<section class="alertsection"><p>識別子:' + preValue + ' 実行コードが未入力です。</p></section>')
            }
        })
        $container.on('mouseenter', '.rectangle', function (e) {
            e.stopPropagation();
            const preValue = this.getAttribute('data-rectangle-id');
            if (this.getAttribute('data-rectangle-exec-value')?.length < 1) {
                this.classList.add('block-alert-border');
                this.classList.add('filter');
                this.querySelector('.block-alert').classList.remove('d-none');
            }
            if (this.classList.contains("block-alert-border")) {
                this.classList.add('filter');
                const preValue = this.getAttribute('data-rectangle-id');

                $('.right-container [data-rectangle-id="' + preValue + '"]').remove()
            }
        }).trigger("mouseenter");

        $container.on('click', '.left-container .rmv', function () {
            const $parent = $(this).parent();
            $(`.right-container .rectangle[data-rectangle-id="${$parent.attr("data-rectangle-id")}"] > .rmv`).click();
            NotifyDialog.showConfirm($container, '選択した短冊型コードを削除します。よろしいですか？', (isOk) => {
                if (isOk) $parent.remove();
            })
        });

        $container.on('click', '.right-container .rmv', function () {
            const $parent = $(this).parent();
            const $addPositionEl = $parent.next();
            const $appendContainer = $parent.parent();
            const appendEl = [];
            $parent.children('.box-none').each((_, nest) => {
                appendEl.push(nest.children);
            })

            if ($addPositionEl.length) {
                for (const el of appendEl)
                    $addPositionEl.before(el);
            } else {
                for (const el of appendEl)
                    $appendContainer.append(
                        el
                    )
            }
            $parent.remove()
            let rectid = $parent[0].getAttribute("data-rectangle-id")
            checkSameLocked(rectid)
        })

        $title.attr('contenteditable', true);

        //問題文フィールド変更
        $title.on('input', () => {
            if ($title.text()) {
                $title.removeClass('cke-placeholder')
            } else {
                $title.addClass('cke-placeholder')
            }
            $title.find('span').removeAttr('style');
            let outputHTML = $title.html().replaceAll("<br>","")
            interaction.triggerPci('changeTitle', [outputHTML]);
        })

        $container.find('.addRectangle').on('click', function () {
            console.log('---addrectangle---')
            const id = createId();
            console.log($container.find(".left-container .rectangle").length);

            if ($container.find(".left-container .rectangle").length >= 30) {
                console.log('tuika--')
                NotifyDialog.showAlert($container, '短冊型コード選択肢に追加できる短冊型コードは、30個までです。');
                return false;
            }
            var rectype = '';
            // // clickしたボタンの種類から種別を分岐する
            if ($(this).hasClass('addfor')) {
                rectype = 'for';
            } else if ($(this).hasClass('addwhile')) {
                rectype = 'while';
            } else if ($(this).hasClass('addcode')) {
                rectype = 'process';
            } else if ($(this).hasClass('addif')) {
                rectype = 'if';
            } else if ($(this).hasClass('addifelse')) {
                rectype = 'ifElse';
            } else if ($(this).hasClass('addprintln')) {
                rectype = 'println';
            } else if ($(this).hasClass('addprint')) {
                rectype = 'print';
            } else if ($(this).hasClass('addFunc')) {
                rectype = 'func';
            }

            const rectangle = Rectangle.createRectangle({id: id, type: rectype, showValue: id.replaceAll('_', "#")});
            $container.find(".left-container").append(rectangle);
        });

        $container.find('.addSpaceBlock').on('click', () => {
            const space_rectangle = '<div class="rectangle spacerectangle">空白パーツ<div class="rmv"><i class="type-close js-remove"></i></div></div>';
            $("#item-editor-choice-property-bar").hide();
            if ($(document).find('.edit-question .right-container .rectangle').length > 30) {
                NotifyDialog.showAlert($container, '解答欄に追加できる短冊型コードは、30個までです。');
            } else {
                $container.find(".right-container").append(space_rectangle);
            }
        });
        $container.find('.spacerectangle').on('click', () => {
            $("#item-editor-choice-property-bar").hide();
        });

        interaction.updateMarkup()
        initialized = true
    }, function (event) {
        observer && observer.disconnect();

        const widget = this.widget;
        const $title = widget.$container.find('.question-title');
        $title.attr('contenteditable', false);
        $title.removeClass('cke-placeholder')
        $title.off('input');

        widget.$container.off('click', '.rectangle');
        widget.$container.off('click', '.left-container .rmv')
        widget.$container.off('click', '.right-container .rmv')

        $(window).trigger('exitQuestion')
        $(document).off('change', '#choicePanel input');
        $(document).off('change', '#choicePanel textarea');

        widget.$container.find('.addRectangle').off('click')
        widget.$container.find('.addSpaceBlock').off('click')
        widget.$container.find('.choicePanel').off('click')

        widget.$container.off('click', '.right-container .lock')
        widget.$container.off('click', '.right-container .locked')

        answerView?.removeEventListeners();
        widget.$container.find('.CodeBlockProgrammingInteraction').off('triggerAddAnswer')


    });
    LiquidsInteractionStateQuestion.prototype.testRun = function () {

    }
    LiquidsInteractionStateQuestion.prototype.initForm = function () {
        var _widget = this.widget,
            $form = _widget.$form,
            interaction = _widget.element,
            response = interaction.getResponseDeclaration();

        let $container = _widget.$container;
        const $title = $container.find('.question-title');


        if (!$title.text()) {
            $title.addClass('cke-placeholder')
        }
        //render the form using the form template
        $form.html(formTpl({
            serial: response.serial,
            identifier: interaction.attr('responseIdentifier')
        }));

        //init form javascript
        formElement.initWidget($form);

        answerView = new AnswerView($form, interaction.properties.options.ansList, interaction);
        answerView.init();

        $container.find('.CodeBlockProgrammingInteraction').on('triggerAddAnswer', function (e) {
            answerView?.changeAnsList(e.detail);
        })

        //init data change callbacks
        formElement.setChangeCallbacks($form, interaction, {

            identifier: function (i, value) {
                response.id(value);
                interaction.attr('responseIdentifier', value);
            }
        });


    };

    return LiquidsInteractionStateQuestion;
});
