requirejs.config({
    paths: {
        jquery: 'CodeBlockProgrammingInteraction/runtime/js/lib/jquery.min'
    }
});

define(['jquery'], function () {

    const TYPE = {
        ALERT: 'alert',
        CONFIRM: 'confirm',
    };

    let showNotifyDialog = function ($root, message, type, callback) {
        let $notifyPopup = $root.find('.popup.notify-popup');
        let $okBtn = $notifyPopup.find('.btn-ok');
        let $cancelBtn = $notifyPopup.find('.btn-cancel');

        $notifyPopup.find('.notify-box h3').text(message);
        $notifyPopup.addClass('is-show');

        $okBtn.off('click').on('click', function(e) {
            e.preventDefault();
            $notifyPopup.removeClass('is-show');
            if (callback) callback(true);
        });

        if (type === TYPE.CONFIRM) {
            $cancelBtn.show();
            $cancelBtn.off('click').on('click', function(e) {
                e.preventDefault();
                $notifyPopup.removeClass('is-show');
                if (callback) callback(false);
            });
        } else {
            $cancelBtn.hide();
        }
    };

    return {
        showAlert($root,message, callback) {
            showNotifyDialog($root, message, TYPE.ALERT, callback);
        },

        showConfirm($root, message, callback) {
            showNotifyDialog($root, message, TYPE.CONFIRM, callback);
        },
    }
});

