requirejs.config({
    paths: {
        jquery: 'CodeBlockProgrammingInteraction/runtime/js/lib/jquery.min'
    }
});

define(['jquery'], function($){


    let StateManager = function() {
        this.$root = null;
        this.allowUpdateAnswerState = false;
        this.questionState = {}
        this.answerState = {}
        this.init();
    };

    StateManager.prototype = {
        init: function ($root, config) {
            this.$root = $root;
            this.config = config;
        },
        saveQuestionStates: function () {
            this.config.states.questionState = this.getState();
            if (this.allowUpdateAnswerState){
                this.config.states.answerState = this.config.states.questionState;
            } else {
                this.allowUpdateAnswerState = true;
            }
        },

        saveAnswerStates: function () {
            this.config.states.answerState = this.getState();
        },

        getState: function () {
            return {
                leftRectangles: this.$root.find('.left-container').html(),
                rightRectangles: this.$root.find('.right-container').html()
            };
        },

        getQuestionState: function () {
            return this.config.states.questionState;
        },
        setQuestionState: function (questionState) {
            this.config.states.questionState = questionState;
        },

        getAnswerState: function () {
            return this.config.states.answerState;
        },
    }

    return StateManager;
});