requirejs.config({
    paths: {
        jquery: 'CodeBlockProgrammingInteraction/runtime/js/lib/jquery.min'
    }
});

define(['jquery'], function () {

    return function createObserver($target, options) {
        let observer = new MutationObserver(records => {
            options?.mutationCallback(records)
        })

        observer.observe($target.get(0), {
            childList: true,
            subtree: true,
            characterData: true,
            attributes: true,
            attributeFilter: options?.attributeFilter
        })
        return observer;
    }
});

